import gleam/erlang/process.{type Subject}
import gleam/http
import gleam/http/request
import gleam/option
import gleam/otp/actor
import stratus

pub fn main() -> Nil {
  Nil
}

pub fn connect(
  token: String,
  initial_state: state,
  on_message: fn(state, stratus.Message(user)) ->
    Result(state, process.ExitReason),
  on_close: fn(state) -> Nil,
) -> Result(Subject(stratus.InternalMessage(user)), actor.StartError) {
  stratus.websocket(
    request: request.Request(
      method: http.Get,
      headers: [#("Authorization", "Bearer " <> token)],
      body: "",
      scheme: http.Https,
      host: "api.spacetraders.io",
      port: option.None,
      path: "/v2/my/socket.io",
      query: option.None,
    ),
    init: fn() { #(initial_state, option.None) },
    loop: fn(msg, state, conn) {
      case on_message(state, msg) {
        Ok(state) -> actor.continue(state)
        Error(reason) -> {
          let _ = stratus.close(conn)
          actor.Stop(reason)
        }
      }
    },
  )
  |> stratus.on_close(on_close)
  |> stratus.initialize
}
